[![Ruby CI](https://github.com/picoruby/prk_firmware/actions/workflows/ruby.yml/badge.svg)](https://github.com/picoruby/prk_firmware/actions/workflows/ruby.yml)

## PRK Firmware

PRK Firmware is an award-winning DIY-keyboard firmware framework written and configured in PicoRuby which is an alternative mruby implementation targeting one-chip microcontrollers.

<div>
<a href="https://rubyprize.jp/21_rubyprize/21_iv-nominees02-en.html" target="_blank">
  <img src="https://hasumikin.com/assets/images/finalnominees-awa-2021.png" width="350" title="Ruby Prize 2021">
</a>
</div>
<div>
<a href="https://www.digitalfukuoka.jp/topics/187" target="_blank">
  <img src="https://github.com/picoruby/picoruby/blob/master/docs/logos/fukuokarubyaward.png?raw=true" width="212" title="Fukuoka Ruby Award 2022">
</a>
</div>

### Features

- A "keymap" can be configured in Ruby which is a concise, readable and happy language
- RP2040 is the target platform microcontroller
- You can extend your keyboard with the power of Ruby (watch the presentation videos below)

### Getting started

See [wiki/Tutorial](https://github.com/picoruby/prk_firmware/wiki/Tutorial)

### Presentations

The author gave a talk about PRK Firmware in RubyConf 2021.

See the video on [YouTube](https://www.youtube.com/watch?v=SLSwn41iJX4&t=12s).

Japanese talk is available at [RubyKaigi Takeout 2021](https://rubykaigi.org/2021-takeout/presentations/hasumikin.html).

### Contributing

Fork, patch and send a pull request.

Unlike QMK Firmware, prk_firmware repository doesn't include individual keymaps.

See also [wiki/README](https://github.com/picoruby/prk_firmware/wiki/README) if you are willing to help us with documentation.

### License

Copyright © 2021-2022 HASUMI Hitoshi ([@hasumikin](https://twitter.com/hasumikin)). See MIT-LICENSE for further details.

<a href="https://github.com/picoruby/picoruby">
  <img src="https://github.com/picoruby/picoruby/blob/master/docs/logos/picoruby.png?raw=true" width="200" alt="PicoRuby" title="Check PicoRuby, too">
</a>
